diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index b2e06262464..49511125897 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -3833,9 +3833,10 @@ async_file_mark (void)
      be awakened anyway.  */
 }
 
-static ptid_t
-linux_wait (ptid_t ptid,
-	    struct target_waitstatus *ourstatus, int target_options)
+ptid_t
+linux_process_target::wait (ptid_t ptid,
+			    target_waitstatus *ourstatus,
+			    int target_options)
 {
   ptid_t event_ptid;
 
@@ -7358,7 +7359,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_wait,
   linux_fetch_registers,
   linux_store_registers,
   linux_prepare_to_access_memory,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index a750f7cca83..d1d89106e50 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -288,6 +288,9 @@ public:
   bool thread_alive (ptid_t pid) override;
 
   void resume (thread_resume *resume_info, size_t n) override;
+
+  ptid_t wait (ptid_t ptid, target_waitstatus *status,
+	       int options) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index 9fc41e4ce99..f38c3110cbd 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -505,12 +505,13 @@ retry:
 /* A wrapper around lynx_wait_1 that also prints debug traces when
    such debug traces have been activated.  */
 
-static ptid_t
-lynx_wait (ptid_t ptid, struct target_waitstatus *status, int options)
+ptid_t
+lynx_process_target::wait (ptid_t ptid, target_waitstatus *status,
+			   int options)
 {
   ptid_t new_ptid;
 
-  lynx_debug ("lynx_wait (pid = %d, tid = %ld)",
+  lynx_debug ("wait (pid = %d, tid = %ld)",
               lynx_ptid_get_pid (ptid), lynx_ptid_get_tid (ptid));
   new_ptid = lynx_wait_1 (ptid, status, options);
   lynx_debug ("          -> (pid=%d, tid=%ld, status->kind = %d)",
@@ -726,7 +727,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_wait,
   lynx_fetch_registers,
   lynx_store_registers,
   NULL,  /* prepare_to_access_memory */
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index 4a5e4ba6f8d..35714713fd2 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -74,6 +74,9 @@ public:
   bool thread_alive (ptid_t pid) override;
 
   void resume (thread_resume *resume_info, size_t n) override;
+
+  ptid_t wait (ptid_t ptid, target_waitstatus *status,
+	       int options) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index d9981540308..6cac6eb4329 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -518,9 +518,9 @@ nto_process_target::resume (thread_resume *resume_info, size_t n)
 
    Return ptid of thread that caused the event.  */
 
-static ptid_t
-nto_wait (ptid_t ptid,
-	  struct target_waitstatus *ourstatus, int target_options)
+ptid_t
+nto_process_target::wait (ptid_t ptid, target_waitstatus *ourstatus,
+			  int target_options)
 {
   sigset_t set;
   siginfo_t info;
@@ -941,7 +941,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_wait,
   nto_fetch_registers,
   nto_store_registers,
   NULL, /* prepare_to_access_memory */
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index 5b32ae7c514..94837ab6051 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -64,6 +64,9 @@ public:
   bool thread_alive (ptid_t pid) override;
 
   void resume (thread_resume *resume_info, size_t n) override;
+
+  ptid_t wait (ptid_t ptid, target_waitstatus *status,
+	       int options) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/target.cc b/gdbserver/target.cc
index eca53de982e..b73c4465f1c 100644
--- a/gdbserver/target.cc
+++ b/gdbserver/target.cc
@@ -223,7 +223,7 @@ target_stop_and_wait (ptid_t ptid)
 ptid_t
 target_wait (ptid_t ptid, struct target_waitstatus *status, int options)
 {
-  return (*the_target->wait) (ptid, status, options);
+  return the_target->pt->wait (ptid, status, options);
 }
 
 /* See target/target.h.  */
diff --git a/gdbserver/target.h b/gdbserver/target.h
index f64009f7521..16daf93440e 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,19 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Wait for the inferior process or thread to change state.  Store
-     status through argument pointer STATUS.
-
-     PTID = -1 to wait for any pid to do something, PTID(pid,0,0) to
-     wait for any thread of process pid to do something.  Return ptid
-     of child, or -1 in case of error; store status through argument
-     pointer STATUS.  OPTIONS is a bit set of options defined as
-     TARGET_W* above.  If options contains TARGET_WNOHANG and there's
-     no child stop to report, return is
-     null_ptid/TARGET_WAITKIND_IGNORE.  */
-
-  ptid_t (*wait) (ptid_t ptid, struct target_waitstatus *status, int options);
-
   /* Fetch registers from the inferior process.
 
      If REGNO is -1, fetch all registers; otherwise, fetch at least REGNO.  */
@@ -482,6 +469,19 @@ public:
 
   /* Resume the inferior process.  */
   virtual void resume (thread_resume *resume_info, size_t n) = 0;
+
+  /* Wait for the inferior process or thread to change state.  Store
+     status through argument pointer STATUS.
+
+     PTID = -1 to wait for any pid to do something, PTID(pid,0,0) to
+     wait for any thread of process pid to do something.  Return ptid
+     of child, or -1 in case of error; store status through argument
+     pointer STATUS.  OPTIONS is a bit set of options defined as
+     TARGET_W* above.  If options contains TARGET_WNOHANG and there's
+     no child stop to report, return is
+     null_ptid/TARGET_WAITKIND_IGNORE.  */
+  virtual ptid_t wait (ptid_t ptid, target_waitstatus *status,
+		       int options) = 0;
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index 1f4af2c66c8..e7df444451d 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -103,8 +103,6 @@ typedef BOOL (WINAPI *winapi_DebugSetProcessKillOnExit) (BOOL KillOnExit);
 typedef BOOL (WINAPI *winapi_DebugBreakProcess) (HANDLE);
 typedef BOOL (WINAPI *winapi_GenerateConsoleCtrlEvent) (DWORD, DWORD);
 
-static ptid_t win32_wait (ptid_t ptid, struct target_waitstatus *ourstatus,
-			  int options);
 #ifndef _WIN32_WCE
 static void win32_add_all_dlls (void);
 #endif
@@ -379,7 +377,7 @@ do_initial_child_stuff (HANDLE proch, DWORD pid, int attached)
     {
       struct target_waitstatus status;
 
-      win32_wait (minus_one_ptid, &status, 0);
+      the_target->pt->wait (minus_one_ptid, &status, 0);
 
       /* Note win32_wait doesn't return thread events.  */
       if (status.kind != TARGET_WAITKIND_LOADED)
@@ -714,7 +712,7 @@ win32_process_target::create_inferior (const char *program,
 
   /* Wait till we are at 1st instruction in program, return new pid
      (assuming success).  */
-  cs.last_ptid = win32_wait (ptid_t (current_process_id), &cs.last_status, 0);
+  cs.last_ptid = wait (ptid_t (current_process_id), &cs.last_status, 0);
 
   /* Necessary for handle_v_kill.  */
   signal_pid = current_process_id;
@@ -1610,8 +1608,9 @@ get_child_debug_event (struct target_waitstatus *ourstatus)
 /* Wait for the inferior process to change state.
    STATUS will be filled in with a response code to send to GDB.
    Returns the signal which caused the process to stop. */
-static ptid_t
-win32_wait (ptid_t ptid, struct target_waitstatus *ourstatus, int options)
+ptid_t
+win32_process_target::wait (ptid_t ptid, target_waitstatus *ourstatus,
+			    int options)
 {
   struct regcache *regcache;
 
@@ -1838,7 +1837,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_wait,
   win32_fetch_inferior_registers,
   win32_store_inferior_registers,
   NULL, /* prepare_to_access_memory */
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index fbdf3c7395a..9c74ffa9c58 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -123,6 +123,9 @@ public:
   bool thread_alive (ptid_t pid) override;
 
   void resume (thread_resume *resume_info, size_t n) override;
+
+  ptid_t wait (ptid_t ptid, target_waitstatus *status,
+	       int options) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */