diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index 3d02cb5431c..47ac768d929 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -5919,11 +5919,18 @@ linux_process_target::request_interrupt ()
   ::kill (-signal_pid, SIGINT);
 }
 
+bool
+linux_process_target::supports_read_auxv ()
+{
+  return true;
+}
+
 /* Copy LEN bytes from inferior's auxiliary vector starting at OFFSET
    to debugger memory starting at MYADDR.  */
 
-static int
-linux_read_auxv (CORE_ADDR offset, unsigned char *myaddr, unsigned int len)
+int
+linux_process_target::read_auxv (CORE_ADDR offset, unsigned char *myaddr,
+				 unsigned int len)
 {
   char filename[PATH_MAX];
   int fd, n;
@@ -7317,7 +7324,7 @@ linux_get_auxv (int wordsize, CORE_ADDR match, CORE_ADDR *valp)
 
   gdb_assert (wordsize == 4 || wordsize == 8);
 
-  while ((*the_target->read_auxv) (offset, data, 2 * wordsize) == 2 * wordsize)
+  while (the_target->pt->read_auxv (offset, data, 2 * wordsize) == 2 * wordsize)
     {
       if (wordsize == 4)
 	{
@@ -7369,7 +7376,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_read_auxv,
   linux_supports_z_point_type,
   linux_insert_point,
   linux_remove_point,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 197a0bbe1d4..0130c22ce27 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -309,6 +309,11 @@ public:
   void look_up_symbols () override;
 
   void request_interrupt () override;
+
+  bool supports_read_auxv () override;
+
+  int read_auxv (CORE_ADDR offset, unsigned char *myaddr,
+		 unsigned int len) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index 8b5300f08c2..bf73e81993e 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -729,7 +729,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  NULL,  /* read_auxv */
   NULL,  /* supports_z_point_type */
   NULL,  /* insert_point */
   NULL,  /* remove_point */
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index d60f72affd5..d828fa7a607 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -755,14 +755,21 @@ nto_process_target::request_interrupt ()
     TRACE ("Error stopping inferior.\n");
 }
 
+bool
+nto_process_target::supports_read_auxv ()
+{
+  return true;
+}
+
 /* Read auxiliary vector from inferior's memory into gdbserver's buffer
    MYADDR.  We always read whole auxv.  
    
    Return number of bytes stored in MYADDR buffer, 0 if OFFSET > 0
    or -1 on error.  */
 
-static int
-nto_read_auxv (CORE_ADDR offset, unsigned char *myaddr, unsigned int len)
+int
+nto_process_target::read_auxv (CORE_ADDR offset, unsigned char *myaddr,
+			       unsigned int len)
 {
   int err;
   CORE_ADDR initial_stack;
@@ -943,7 +950,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_read_auxv,
   nto_supports_z_point_type,
   nto_insert_point,
   nto_remove_point,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index c6e0c295662..e135dd3b68a 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -79,6 +79,11 @@ public:
 		    int len) override;
 
   void request_interrupt () override;
+
+  bool supports_read_auxv () override;
+
+  int read_auxv (CORE_ADDR offset, unsigned char *myaddr,
+		 unsigned int len) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/server.cc b/gdbserver/server.cc
index bc497f87b7f..f13061c871b 100644
--- a/gdbserver/server.cc
+++ b/gdbserver/server.cc
@@ -1442,13 +1442,13 @@ handle_qxfer_auxv (const char *annex,
 		   gdb_byte *readbuf, const gdb_byte *writebuf,
 		   ULONGEST offset, LONGEST len)
 {
-  if (the_target->read_auxv == NULL || writebuf != NULL)
+  if (!the_target->pt->supports_read_auxv () || writebuf != NULL)
     return -2;
 
   if (annex[0] != '\0' || current_thread == NULL)
     return -1;
 
-  return (*the_target->read_auxv) (offset, readbuf, len);
+  return the_target->pt->read_auxv (offset, readbuf, len);
 }
 
 /* Handle qXfer:exec-file:read.  */
@@ -2374,7 +2374,7 @@ handle_query (char *own_buf, int packet_len, int *new_packet_len_p)
 	  strcat (own_buf, ";qXfer:libraries:read+");
 	}
 
-      if (the_target->read_auxv != NULL)
+      if (the_target->pt->supports_read_auxv ())
 	strcat (own_buf, ";qXfer:auxv:read+");
 
       if (the_target->qxfer_siginfo != NULL)
diff --git a/gdbserver/target.cc b/gdbserver/target.cc
index dd9ee8dfd47..97e9d4ac507 100644
--- a/gdbserver/target.cc
+++ b/gdbserver/target.cc
@@ -414,3 +414,16 @@ process_target::look_up_symbols ()
 {
   /* Nop.  */
 }
+
+bool
+process_target::supports_read_auxv ()
+{
+  return false;
+}
+
+int
+process_target::read_auxv (CORE_ADDR offset, unsigned char *myaddr,
+			   unsigned int len)
+{
+  gdb_assert_not_reached ("target op read_auxv not supported");
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 234a183427e..cd11da670ca 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,13 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Read auxiliary vector data from the inferior process.
-
-     Read LEN bytes at OFFSET into a buffer at MYADDR.  */
-
-  int (*read_auxv) (CORE_ADDR offset, unsigned char *myaddr,
-		    unsigned int len);
-
   /* Returns true if GDB Z breakpoint type TYPE is supported, false
      otherwise.  The type is coded as follows:
        '0' - software-breakpoint
@@ -474,6 +467,15 @@ public:
   /* Send an interrupt request to the inferior process,
      however is appropriate.  */
   virtual void request_interrupt () = 0;
+
+  /* Return true if the read_auxv target op is supported.  */
+  virtual bool supports_read_auxv ();
+
+  /* Read auxiliary vector data from the inferior process.
+
+     Read LEN bytes at OFFSET into a buffer at MYADDR.  */
+  virtual int read_auxv (CORE_ADDR offset, unsigned char *myaddr,
+			 unsigned int len);
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index 098da30017d..2d617d889ec 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -1838,7 +1838,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  NULL, /* read_auxv */
   win32_supports_z_point_type,
   win32_insert_point,
   win32_remove_point,