diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index 9ad5e19207a..fec2c3c5673 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -6032,8 +6032,8 @@ linux_process_target::supports_stopped_by_hw_breakpoint ()
 
 /* Implement the supports_hardware_single_step target_ops method.  */
 
-static int
-linux_supports_hardware_single_step (void)
+bool
+linux_process_target::supports_hardware_single_step ()
 {
   return can_hardware_single_step ();
 }
@@ -7376,7 +7376,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_supports_hardware_single_step,
   linux_stopped_by_watchpoint,
   linux_stopped_data_address,
 #if defined(__UCLIBC__) && defined(HAS_NOMMU)	      \
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 95dabf3a44e..57fc9a59415 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -330,6 +330,8 @@ public:
   bool stopped_by_hw_breakpoint () override;
 
   bool supports_stopped_by_hw_breakpoint () override;
+
+  bool supports_hardware_single_step () override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index e4f276b5af0..ea328b7efe3 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -722,6 +722,12 @@ lynx_process_target::request_interrupt ()
   kill (lynx_ptid_get_pid (inferior_ptid), SIGINT);
 }
 
+bool
+lynx_process_target::supports_hardware_single_step ()
+{
+  return true;
+}
+
 /* The LynxOS target ops object.  */
 
 static lynx_process_target the_lynx_target;
@@ -729,7 +735,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  target_can_do_hardware_single_step,
   NULL,  /* stopped_by_watchpoint */
   NULL,  /* stopped_data_address */
   NULL,  /* read_offsets */
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index 795603af0d7..4253f1259c2 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -89,6 +89,8 @@ public:
 		    int len) override;
 
   void request_interrupt () override;
+
+  bool supports_hardware_single_step () override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index 6bb926d5278..3e10436df3d 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -869,6 +869,12 @@ nto_process_target::remove_point (enum raw_bkpt_type type, CORE_ADDR addr,
   return nto_breakpoint (addr, wtype, -1);
 }
 
+bool
+nto_process_target::supports_hardware_single_step ()
+{
+  return true;
+}
+
 /* Check if the reason of stop for current thread (CURRENT_INFERIOR) is
    a watchpoint.
 
@@ -950,7 +956,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  target_can_do_hardware_single_step,
   nto_stopped_by_watchpoint,
   nto_stopped_data_address,
   NULL, /* nto_read_offsets */
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index b0b276319d2..001ccb6687c 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -92,6 +92,8 @@ public:
 
   int remove_point (enum raw_bkpt_type type, CORE_ADDR addr,
 		    int size, raw_breakpoint *bp) override;
+
+  bool supports_hardware_single_step () override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/target.cc b/gdbserver/target.cc
index f7dc0f4d658..09b3a633fc8 100644
--- a/gdbserver/target.cc
+++ b/gdbserver/target.cc
@@ -316,14 +316,6 @@ kill_inferior (process_info *proc)
   return the_target->pt->kill (proc);
 }
 
-/* Target can do hardware single step.  */
-
-int
-target_can_do_hardware_single_step (void)
-{
-  return 1;
-}
-
 /* Default implementation for breakpoint_kind_for_pc.
 
    The default behavior for targets that don't implement breakpoint_kind_for_pc
@@ -471,3 +463,9 @@ process_target::supports_stopped_by_hw_breakpoint ()
 {
   return false;
 }
+
+bool
+process_target::supports_hardware_single_step ()
+{
+  return false;
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index c5b1ef21b07..92b85cb061e 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,9 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Returns true if the target can do hardware single step.  */
-  int (*supports_hardware_single_step) (void);
-
   /* Returns 1 if target was stopped due to a watchpoint hit, 0 otherwise.  */
 
   int (*stopped_by_watchpoint) (void);
@@ -476,6 +473,9 @@ public:
   /* Returns true if the target knows whether a trap was caused by a
      HW breakpoint triggering.  */
   virtual bool supports_stopped_by_hw_breakpoint ();
+
+  /* Returns true if the target can do hardware single step.  */
+  virtual bool supports_hardware_single_step ();
 };
 
 extern process_stratum_target *the_target;
@@ -668,8 +668,7 @@ target_read_btrace_conf (struct btrace_target_info *tinfo,
   the_target->pt->supports_stopped_by_hw_breakpoint ()
 
 #define target_supports_hardware_single_step() \
-  (the_target->supports_hardware_single_step ? \
-   (*the_target->supports_hardware_single_step) () : 0)
+  the_target->pt->supports_hardware_single_step ()
 
 #define target_stopped_by_hw_breakpoint() \
   the_target->pt->stopped_by_hw_breakpoint ()
@@ -720,8 +719,6 @@ int set_desired_thread ();
 
 const char *target_pid_to_str (ptid_t);
 
-int target_can_do_hardware_single_step (void);
-
 int default_breakpoint_kind_from_pc (CORE_ADDR *pcptr);
 
 #endif /* GDBSERVER_TARGET_H */
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index 7edad620050..2862a9c241c 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -1728,6 +1728,12 @@ win32_process_target::request_interrupt ()
   soft_interrupt_requested = 1;
 }
 
+bool
+win32_process_target::supports_hardware_single_step ()
+{
+  return true;
+}
+
 #ifdef _WIN32_WCE
 int
 win32_error_to_fileio_error (DWORD err)
@@ -1838,7 +1844,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  target_can_do_hardware_single_step,
   win32_stopped_by_watchpoint,
   win32_stopped_data_address,
   NULL, /* read_offsets */
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index a6b27918f4c..c5f9a13e029 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -146,6 +146,8 @@ public:
 
   int remove_point (enum raw_bkpt_type type, CORE_ADDR addr,
 		    int size, raw_breakpoint *bp) override;
+
+  bool supports_hardware_single_step () override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */