diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index 4510e3a1c5f..1feb7d971cd 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -1603,8 +1603,8 @@ linux_detach_lwp_callback (thread_info *thread)
   linux_detach_one_lwp (lwp);
 }
 
-static int
-linux_detach (process_info *process)
+int
+linux_process_target::detach (process_info *process)
 {
   struct lwp_info *main_lwp;
 
@@ -7359,7 +7359,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_detach,
   linux_mourn,
   linux_join,
   linux_thread_alive,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 4f8801150d5..e8789e9c8a9 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -278,6 +278,8 @@ public:
   int attach (unsigned long pid) override;
 
   int kill (process_info *proc) override;
+
+  int detach (process_info *proc) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index f6359e81575..a6eceaf25b1 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -535,8 +535,8 @@ lynx_process_target::kill (process_info *process)
 
 /* Implement the detach target_ops method.  */
 
-static int
-lynx_detach (process_info *process)
+int
+lynx_process_target::detach (process_info *process)
 {
   ptid_t ptid = lynx_ptid_t (process->pid, 0);
 
@@ -726,7 +726,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_detach,
   lynx_mourn,
   lynx_join,
   lynx_thread_alive,
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index cf357ff9a1f..9b8065e3f37 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -64,6 +64,8 @@ public:
   int attach (unsigned long pid) override;
 
   int kill (process_info *proc) override;
+
+  int detach (process_info *proc) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index 15b3dc37f01..ceff0d432e5 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -409,8 +409,8 @@ nto_process_target::kill (process_info *proc)
 
 /* Detach from process PID.  */
 
-static int
-nto_detach (process_info *proc)
+int
+nto_process_target::detach (process_info *proc)
 {
   TRACE ("%s %d\n", __func__, proc->pid);
   do_detach ();
@@ -935,7 +935,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_detach,
   nto_mourn,
   NULL, /* nto_join */
   nto_thread_alive,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index 5564dda3bb2..e7e10fcb842 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -54,6 +54,8 @@ public:
   int attach (unsigned long pid) override;
 
   int kill (process_info *proc) override;
+
+  int detach (process_info *proc) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 0f3cb35f453..6c7c2869938 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,11 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Detach from process PROC.  Return -1 on failure, and 0 on
-     success.  */
-
-  int (*detach) (process_info *proc);
-
   /* The inferior process has died.  Do what is right.  */
 
   void (*mourn) (struct process_info *proc);
@@ -487,6 +482,10 @@ public:
 
   /* Kill process PROC.  Return -1 on failure, and 0 on success.  */
   virtual int kill (process_info *proc) = 0;
+
+  /* Detach from process PROC.  Return -1 on failure, and 0 on
+     success.  */
+  virtual int detach (process_info *proc) = 0;
 };
 
 extern process_stratum_target *the_target;
@@ -524,7 +523,7 @@ int kill_inferior (process_info *proc);
     } while (0)
 
 #define detach_inferior(proc) \
-  (*the_target->detach) (proc)
+  the_target->pt->detach (proc)
 
 #define mythread_alive(pid) \
   (*the_target->thread_alive) (pid)
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index a7fb1244e34..9cefb29b046 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -843,8 +843,8 @@ win32_process_target::kill (process_info *process)
 
 /* Implementation of target_ops::detach.  */
 
-static int
-win32_detach (process_info *process)
+int
+win32_process_target::detach (process_info *process)
 {
   winapi_DebugActiveProcessStop DebugActiveProcessStop = NULL;
   winapi_DebugSetProcessKillOnExit DebugSetProcessKillOnExit = NULL;
@@ -1839,7 +1839,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_detach,
   win32_mourn,
   win32_join,
   win32_thread_alive,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index 45a6262e38e..10096b87682 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -113,6 +113,8 @@ public:
   int attach (unsigned long pid) override;
 
   int kill (process_info *proc) override;
+
+  int detach (process_info *proc) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */