diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index 1a790e5eae9..f073a38f092 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -5898,8 +5898,8 @@ linux_process_target::write_memory (CORE_ADDR memaddr,
   return 0;
 }
 
-static void
-linux_look_up_symbols (void)
+void
+linux_process_target::look_up_symbols ()
 {
 #ifdef USE_THREAD_DB
   struct process_info *proc = current_process ();
@@ -7369,7 +7369,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_look_up_symbols,
   linux_request_interrupt,
   linux_read_auxv,
   linux_supports_z_point_type,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index b8b10143dec..05269dc18ab 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -305,6 +305,8 @@ public:
 
   int write_memory (CORE_ADDR memaddr, const unsigned char *myaddr,
 		    int len) override;
+
+  void look_up_symbols () override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index eb5147d907b..bedf9182ce2 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -729,7 +729,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  NULL,  /* look_up_symbols */
   lynx_request_interrupt,
   NULL,  /* read_auxv */
   NULL,  /* supports_z_point_type */
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index d56f247acb4..c229e41d525 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -943,7 +943,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  NULL, /* nto_look_up_symbols */
   nto_request_interrupt,
   nto_read_auxv,
   nto_supports_z_point_type,
diff --git a/gdbserver/server.cc b/gdbserver/server.cc
index 92feff36516..4785eabaf06 100644
--- a/gdbserver/server.cc
+++ b/gdbserver/server.cc
@@ -2192,8 +2192,8 @@ handle_query (char *own_buf, int packet_len, int *new_packet_len_p)
       if (target_supports_tracepoints ())
 	tracepoint_look_up_symbols ();
 
-      if (current_thread != NULL && the_target->look_up_symbols != NULL)
-	(*the_target->look_up_symbols) ();
+      if (current_thread != NULL)
+	the_target->pt->look_up_symbols ();
 
       current_thread = save_thread;
 
diff --git a/gdbserver/target.cc b/gdbserver/target.cc
index 49302f61dfb..dd9ee8dfd47 100644
--- a/gdbserver/target.cc
+++ b/gdbserver/target.cc
@@ -408,3 +408,9 @@ process_target::done_accessing_memory ()
 {
   /* Nop.  */
 }
+
+void
+process_target::look_up_symbols ()
+{
+  /* Nop.  */
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index ead4a613e90..7f37a904f76 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,14 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Query GDB for the values of any symbols we're interested in.
-     This function is called whenever we receive a "qSymbols::"
-     query, which corresponds to every time more symbols (might)
-     become available.  NULL if we aren't interested in any
-     symbols.  */
-
-  void (*look_up_symbols) (void);
-
   /* Send an interrupt request to the inferior process,
      however is appropriate.  */
 
@@ -477,6 +469,12 @@ public:
      Returns 0 on success and errno on failure.  */
   virtual int write_memory (CORE_ADDR memaddr, const unsigned char *myaddr,
 			    int len) = 0;
+
+  /* Query GDB for the values of any symbols we're interested in.
+     This function is called whenever we receive a "qSymbols::"
+     query, which corresponds to every time more symbols (might)
+     become available.  */
+  virtual void look_up_symbols ();
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index ef0d6035e93..4ac1b3a1ca2 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -1838,7 +1838,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  NULL, /* lookup_symbols */
   win32_request_interrupt,
   NULL, /* read_auxv */
   win32_supports_z_point_type,