diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index 1af37044a8e..e5e32006496 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -6426,13 +6426,13 @@ linux_process_target::supports_agent ()
   return true;
 }
 
-static int
-linux_supports_range_stepping (void)
+bool
+linux_process_target::supports_range_stepping ()
 {
   if (can_software_single_step ())
-    return 1;
+    return true;
   if (*the_low_target.supports_range_stepping == NULL)
-    return 0;
+    return false;
 
   return (*the_low_target.supports_range_stepping) ();
 }
@@ -7467,7 +7467,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_supports_range_stepping,
   linux_proc_pid_to_exec_file,
   linux_mntns_open_cloexec,
   linux_mntns_unlink,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 8c33dccc678..f47d9ed816f 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -446,6 +446,8 @@ public:
   int read_btrace_conf (const btrace_target_info *tinfo,
 			buffer *buf) override;
 #endif
+
+  bool supports_range_stepping () override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index a890b660bb1..854037a631b 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -735,7 +735,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  NULL,  /* supports_range_stepping */
   NULL,  /* pid_to_exec_file */
   NULL,  /* multifs_open */
   NULL,  /* multifs_unlink */
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index ef79105877b..3532aa460f0 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -947,7 +947,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  NULL, /* supports_range_stepping */
   NULL, /* pid_to_exec_file */
   NULL, /* multifs_open */
   NULL, /* multifs_unlink */
diff --git a/gdbserver/target.cc b/gdbserver/target.cc
index e2ce7ff0869..8739ba864f8 100644
--- a/gdbserver/target.cc
+++ b/gdbserver/target.cc
@@ -753,3 +753,9 @@ process_target::read_btrace_conf (const btrace_target_info *tinfo,
 {
   error (_("Target does not support branch tracing."));
 }
+
+bool
+process_target::supports_range_stepping ()
+{
+  return false;
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 9d7c599b1e6..cdb3c119433 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,9 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Return true if target supports range stepping.  */
-  int (*supports_range_stepping) (void);
-
   /* Return the full absolute name of the executable file that was
      run to create the process PID.  If the executable file cannot
      be determined, NULL is returned.  Otherwise, a pointer to a
@@ -498,6 +495,9 @@ public:
      otherwise.  */
   virtual int read_btrace_conf (const btrace_target_info *tinfo,
 				buffer *buf);
+
+  /* Return true if target supports range stepping.  */
+  virtual bool supports_range_stepping ();
 };
 
 extern process_stratum_target *the_target;
@@ -638,8 +638,7 @@ target_read_btrace_conf (struct btrace_target_info *tinfo,
 }
 
 #define target_supports_range_stepping() \
-  (the_target->supports_range_stepping ? \
-   (*the_target->supports_range_stepping) () : 0)
+  the_target->pt->supports_range_stepping ()
 
 #define target_supports_stopped_by_sw_breakpoint() \
   the_target->pt->supports_stopped_by_sw_breakpoint ()
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index 7fdc90feff1..b270745275f 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -1858,7 +1858,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  NULL, /* supports_range_stepping */
   NULL, /* pid_to_exec_file */
   NULL, /* multifs_open */
   NULL, /* multifs_unlink */