diff --git a/gdbserver/linux-low.cc b/gdbserver/linux-low.cc
index 692863d9e4b..c75d4ba9707 100644
--- a/gdbserver/linux-low.cc
+++ b/gdbserver/linux-low.cc
@@ -7451,7 +7451,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  NULL,
   linux_pause_all,
   linux_unpause_all,
   linux_stabilize_threads,
diff --git a/gdbserver/lynx-low.cc b/gdbserver/lynx-low.cc
index 7cbde7c6e79..9f96faf802c 100644
--- a/gdbserver/lynx-low.cc
+++ b/gdbserver/lynx-low.cc
@@ -735,7 +735,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  NULL,  /* get_tib_address */
   NULL,  /* pause_all */
   NULL,  /* unpause_all */
   NULL,  /* stabilize_threads */
diff --git a/gdbserver/nto-low.cc b/gdbserver/nto-low.cc
index c144d774f0c..08f73fa3871 100644
--- a/gdbserver/nto-low.cc
+++ b/gdbserver/nto-low.cc
@@ -947,7 +947,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  NULL, /* get_tib_address */
   NULL, /* pause_all */
   NULL, /* unpause_all */
   NULL, /* stabilize_threads */
diff --git a/gdbserver/server.cc b/gdbserver/server.cc
index f3dca8d3ce0..77155935fab 100644
--- a/gdbserver/server.cc
+++ b/gdbserver/server.cc
@@ -2532,7 +2532,7 @@ handle_query (char *own_buf, int packet_len, int *new_packet_len_p)
     }
 
   /* Windows OS Thread Information Block address support.  */
-  if (the_target->get_tib_address != NULL
+  if (the_target->pt->supports_get_tib_address ()
       && startswith (own_buf, "qGetTIBAddr:"))
     {
       const char *annex;
@@ -2540,7 +2540,7 @@ handle_query (char *own_buf, int packet_len, int *new_packet_len_p)
       CORE_ADDR tlb;
       ptid_t ptid = read_ptid (own_buf + 12, &annex);
 
-      n = (*the_target->get_tib_address) (ptid, &tlb);
+      n = the_target->pt->get_tib_address (ptid, &tlb);
       if (n == 1)
 	{
 	  strcpy (own_buf, paddress(tlb));
diff --git a/gdbserver/target.cc b/gdbserver/target.cc
index b44170a7cdd..680addadf78 100644
--- a/gdbserver/target.cc
+++ b/gdbserver/target.cc
@@ -638,3 +638,15 @@ process_target::thread_stopped (thread_info *thread)
 {
   gdb_assert_not_reached ("target op thread_stopped not supported");
 }
+
+bool
+process_target::supports_get_tib_address ()
+{
+  return false;
+}
+
+int
+process_target::get_tib_address (ptid_t ptid, CORE_ADDR *address)
+{
+  gdb_assert_not_reached ("target op get_tib_address not supported");
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 49d5eca479e..4da15a06734 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,9 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Read Thread Information Block address.  */
-  int (*get_tib_address) (ptid_t ptid, CORE_ADDR *address);
-
   /* Pause all threads.  If FREEZE, arrange for any resume attempt to
      be ignored until an unpause_all call unfreezes threads again.
      There can be nested calls to pause_all, so a freeze counter
@@ -491,6 +488,12 @@ public:
 
   /* Return true if THREAD is known to be stopped now.  */
   virtual bool thread_stopped (thread_info *thread);
+
+  /* Return true if the get_tib_address op is supported.  */
+  virtual bool supports_get_tib_address ();
+
+  /* Read Thread Information Block address.  */
+  virtual int get_tib_address (ptid_t ptid, CORE_ADDR *address);
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.cc b/gdbserver/win32-low.cc
index 712624852d6..9bffdaaf1ae 100644
--- a/gdbserver/win32-low.cc
+++ b/gdbserver/win32-low.cc
@@ -1824,10 +1824,16 @@ win32_process_target::qxfer_siginfo (const char *annex,
   return len;
 }
 
+bool
+win32_process_target::supports_get_tib_address ()
+{
+  return true;
+}
+
 /* Write Windows OS Thread Information Block address.  */
 
-static int
-win32_get_tib_address (ptid_t ptid, CORE_ADDR *addr)
+int
+win32_process_target::get_tib_address (ptid_t ptid, CORE_ADDR *addr)
 {
   win32_thread_info *th;
   th = thread_rec (ptid, 0);
@@ -1852,7 +1858,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_get_tib_address,
   NULL, /* pause_all */
   NULL, /* unpause_all */
   NULL, /* stabilize_threads */
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index b259b1fbac1..1618501838e 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -162,6 +162,10 @@ public:
   int qxfer_siginfo (const char *annex, unsigned char *readbuf,
 		     unsigned const char *writebuf,
 		     CORE_ADDR offset, int len) override;
+
+  bool supports_get_tib_address () override;
+
+  int get_tib_address (ptid_t ptid, CORE_ADDR *addr) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */